]> git.proxmox.com Git - mirror_lxc.git/blame - templates/lxc-download.in
Merge pull request #3052 from tanyifeng/fd_leak
[mirror_lxc.git] / templates / lxc-download.in
CommitLineData
71d3a659
SG
1#!/bin/sh
2
3# Client script for LXC container images.
4#
5# Copyright © 2014 Stéphane Graber <stgraber@ubuntu.com>
6#
7# This library is free software; you can redistribute it and/or
8# modify it under the terms of the GNU Lesser General Public
9# License as published by the Free Software Foundation; either
10# version 2.1 of the License, or (at your option) any later version.
11
12# This library is distributed in the hope that it will be useful,
13# but WITHOUT ANY WARRANTY; without even the implied warranty of
14# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
15# Lesser General Public License for more details.
16
17# You should have received a copy of the GNU Lesser General Public
18# License along with this library; if not, write to the Free Software
19# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301
20# USA
21
22set -eu
23
71d3a659 24LOCALSTATEDIR="@LOCALSTATEDIR@"
f74e080c
SG
25LXC_HOOK_DIR="@LXCHOOKDIR@"
26LXC_TEMPLATE_CONFIG="@LXCTEMPLATECONFIG@"
71d3a659
SG
27
28# Defaults
71d3a659 29DOWNLOAD_ARCH=
f74e080c 30DOWNLOAD_BUILD=
b80f86f2 31DOWNLOAD_COMPAT_LEVEL=5
f74e080c 32DOWNLOAD_DIST=
71d3a659 33DOWNLOAD_FLUSH_CACHE="false"
41670b35 34DOWNLOAD_FORCE_CACHE="false"
f74e080c 35DOWNLOAD_INTERACTIVE="false"
dd2dbcb9 36DOWNLOAD_KEYID="0xE7FB0CAEC8173D669066514CBAEFF88C22F6E216"
f74e080c 37DOWNLOAD_LIST_IMAGES="false"
71d3a659 38DOWNLOAD_MODE="system"
b0f0932a 39DOWNLOAD_READY_GPG="false"
f74e080c
SG
40DOWNLOAD_RELEASE=
41DOWNLOAD_SERVER="images.linuxcontainers.org"
42DOWNLOAD_SHOW_GPG_WARNING="true"
43DOWNLOAD_SHOW_HTTP_WARNING="true"
44DOWNLOAD_TARGET="system"
45DOWNLOAD_URL=
46DOWNLOAD_USE_CACHE="false"
47DOWNLOAD_VALIDATE="true"
48DOWNLOAD_VARIANT="default"
edb5452c 49DOWNLOAD_TEMP=
71d3a659 50
f74e080c
SG
51LXC_MAPPED_GID=
52LXC_MAPPED_UID=
71d3a659
SG
53LXC_NAME=
54LXC_PATH=
55LXC_ROOTFS=
71d3a659 56
a9a53b50 57if [ -z "${DOWNLOAD_KEYSERVER:-}" ]; then
832cb182 58 DOWNLOAD_KEYSERVER="hkp://pool.sks-keyservers.net"
a6a7c7d1 59
832cb182
CB
60 # Deal with GPG over http proxy
61 if [ -n "${http_proxy:-}" ]; then
62 DOWNLOAD_KEYSERVER="hkp://p80.pool.sks-keyservers.net:80"
41440801 63 DOWNLOAD_GPG_PROXY="--keyserver-options http-proxy=\"${http_proxy}\""
832cb182 64 fi
4eb706b3
SG
65fi
66
207bf0e4
SG
67# Make sure the usual locations are in PATH
68export PATH=$PATH:/usr/sbin:/usr/bin:/sbin:/bin
69
71d3a659
SG
70# Some useful functions
71cleanup() {
832cb182
CB
72 if [ -d "${DOWNLOAD_TEMP}" ]; then
73 rm -Rf "${DOWNLOAD_TEMP}"
74 fi
71d3a659
SG
75}
76
acabe1fa 77wget_wrapper() {
832cb182
CB
78 for _ in $(seq 3); do
79 if wget "$@"; then
80 return 0
81 fi
82 done
acabe1fa 83
832cb182 84 return 1
acabe1fa
SG
85}
86
71d3a659 87download_file() {
832cb182
CB
88 if ! wget_wrapper -T 30 -q "https://${DOWNLOAD_SERVER}/$1" -O "$2" >/dev/null 2>&1; then
89 if ! wget_wrapper -T 30 -q "http://${DOWNLOAD_SERVER}/$1" -O "$2" >/dev/null 2>&1; then
90 if [ "$3" = "noexit" ]; then
91 return 1
92 else
93 echo "ERROR: Failed to download http://${DOWNLOAD_SERVER}/$1" 1>&2
94 exit 1
95 fi
96 elif [ "${DOWNLOAD_SHOW_HTTP_WARNING}" = "true" ]; then
97 DOWNLOAD_SHOW_HTTP_WARNING="false"
98 echo "WARNING: Failed to download the file over HTTPs" 1>&2
99 echo " The file was instead download over HTTP " 1>&2
100 echo "A server replay attack may be possible!" 1>&2
71d3a659 101 fi
832cb182 102 fi
71d3a659
SG
103}
104
fad96766 105download_sig() {
832cb182
CB
106 if ! download_file "$1" "$2" noexit; then
107 if [ "${DOWNLOAD_VALIDATE}" = "true" ]; then
108 if [ "$3" = "normal" ]; then
109 echo "ERROR: Failed to download http://${DOWNLOAD_SERVER}/$1" 1>&2
110 exit 1
111 else
112 return 1
113 fi
114 else
115 return 0
fad96766 116 fi
832cb182 117 fi
fad96766
DE
118}
119
71d3a659 120gpg_setup() {
832cb182
CB
121 if [ "${DOWNLOAD_VALIDATE}" = "false" ]; then
122 return
123 fi
124
125 if [ "${DOWNLOAD_READY_GPG}" = "true" ]; then
126 return
127 fi
128
129 echo "Setting up the GPG keyring"
130
131 mkdir -p "${DOWNLOAD_TEMP}/gpg"
132 chmod 700 "${DOWNLOAD_TEMP}/gpg"
133 export GNUPGHOME="${DOWNLOAD_TEMP}/gpg"
134
135 success=
136 for _ in $(seq 3); do
41440801
MD
137 if $(gpg --keyserver "${DOWNLOAD_KEYSERVER}" ${DOWNLOAD_GPG_PROXY:-} \
138 --recv-keys "${DOWNLOAD_KEYID}" >/dev/null 2>&1); then
832cb182
CB
139 success=1
140 break
71d3a659 141 fi
832cb182
CB
142 break
143 done
71d3a659 144
832cb182
CB
145 if [ -z "${success}" ]; then
146 echo "ERROR: Unable to fetch GPG key from keyserver"
147 exit 1
148 fi
b0f0932a 149
832cb182 150 DOWNLOAD_READY_GPG="true"
71d3a659
SG
151}
152
153gpg_validate() {
832cb182
CB
154 if [ "${DOWNLOAD_VALIDATE}" = "false" ]; then
155 if [ "${DOWNLOAD_SHOW_GPG_WARNING}" = "true" ]; then
156 echo "WARNING: Running without gpg validation!" 1>&2
71d3a659 157 fi
832cb182
CB
158 DOWNLOAD_SHOW_GPG_WARNING="false"
159 return 0
160 fi
71d3a659 161
832cb182
CB
162 if ! gpg --verify "$1" >/dev/null 2>&1; then
163 echo "ERROR: Invalid signature for $1" 1>&2
164 exit 1
165 fi
71d3a659
SG
166}
167
168in_userns() {
832cb182
CB
169 [ -e /proc/self/uid_map ] || { echo no; return; }
170 while read -r line; do
171 fields="$(echo "$line" | awk '{ print $1 " " $2 " " $3 }')"
172 if [ "${fields}" = "0 0 4294967295" ]; then
173 echo no;
174 return;
175 fi
176 if echo "${fields}" | grep -q " 0 1$"; then
177 echo userns-root;
178 return;
179 fi
180 done < /proc/self/uid_map
181
182 [ "$(cat /proc/self/uid_map)" = "$(cat /proc/1/uid_map)" ] && { echo userns-root; return; }
183 echo yes
71d3a659
SG
184}
185
186relevant_file() {
832cb182
CB
187 FILE_PATH="${LXC_CACHE_PATH}/$1"
188
189 if [ -e "${FILE_PATH}-${DOWNLOAD_MODE}" ]; then
190 FILE_PATH="${FILE_PATH}-${DOWNLOAD_MODE}"
191 fi
71d3a659 192
832cb182
CB
193 if [ -e "${FILE_PATH}.${DOWNLOAD_COMPAT_LEVEL}" ]; then
194 FILE_PATH="${FILE_PATH}.${DOWNLOAD_COMPAT_LEVEL}"
195 fi
196
197 echo "${FILE_PATH}"
71d3a659
SG
198}
199
200usage() {
832cb182 201 cat <<EOF
71d3a659
SG
202LXC container image downloader
203
7d540a26 204Special arguments:
832cb182
CB
205[ -h | --help ]: Print this help message and exit
206[ -l | --list ]: List all available images and exit
7d540a26 207
71d3a659
SG
208Required arguments:
209[ -d | --dist <distribution> ]: The name of the distribution
210[ -r | --release <release> ]: Release name/version
211[ -a | --arch <architecture> ]: Architecture of the container
71d3a659
SG
212
213Optional arguments:
214[ --variant <variant> ]: Variant of the image (default: "default")
215[ --server <server> ]: Image server (default: "images.linuxcontainers.org")
216[ --keyid <keyid> ]: GPG keyid (default: 0x...)
d2e5c5d1 217[ --keyserver <keyserver> ]: GPG keyserver to use. Environment variable: DOWNLOAD_KEYSERVER
71d3a659
SG
218[ --no-validate ]: Disable GPG validation (not recommended)
219[ --flush-cache ]: Flush the local copy (if present)
e145b7bb 220[ --force-cache ]: Force the use of the local copy even if expired
71d3a659
SG
221
222LXC internal arguments (do not pass manually!):
223[ --name <name> ]: The container name
224[ --path <path> ]: The path to the container
225[ --rootfs <rootfs> ]: The path to the container's rootfs
2133f58c
SH
226[ --mapped-uid <map> ]: A uid map (user namespaces)
227[ --mapped-gid <map> ]: A gid map (user namespaces)
d2e5c5d1
TK
228
229Environment Variables:
230DOWNLOAD_KEYSERVER : The URL of the key server to use, instead of the default.
231 Can be further overridden by using optional argument --keyserver
232
71d3a659 233EOF
832cb182 234 return 0
71d3a659
SG
235}
236
3f7be9d0 237if ! options=$(getopt -o d:r:a:hl -l dist:,release:,arch:,help,list,variant:,\
3cd988cc 238server:,keyid:,keyserver:,no-validate,flush-cache,force-cache,name:,path:,\
3f7be9d0 239rootfs:,mapped-uid:,mapped-gid: -- "$@"); then
832cb182
CB
240 usage
241 exit 1
71d3a659
SG
242fi
243eval set -- "$options"
244
245while :; do
832cb182
CB
246 case "$1" in
247 -h|--help) usage && exit 1;;
248 -l|--list) DOWNLOAD_LIST_IMAGES="true"; shift 1;;
249 -d|--dist) DOWNLOAD_DIST="$2"; shift 2;;
250 -r|--release) DOWNLOAD_RELEASE="$2"; shift 2;;
251 -a|--arch) DOWNLOAD_ARCH="$2"; shift 2;;
252 --variant) DOWNLOAD_VARIANT="$2"; shift 2;;
253 --server) DOWNLOAD_SERVER="$2"; shift 2;;
254 --keyid) DOWNLOAD_KEYID="$2"; shift 2;;
255 --keyserver) DOWNLOAD_KEYSERVER="$2"; shift 2;;
256 --no-validate) DOWNLOAD_VALIDATE="false"; shift 1;;
257 --flush-cache) DOWNLOAD_FLUSH_CACHE="true"; shift 1;;
258 --force-cache) DOWNLOAD_FORCE_CACHE="true"; shift 1;;
259 --name) LXC_NAME="$2"; shift 2;;
260 --path) LXC_PATH="$2"; shift 2;;
261 --rootfs) LXC_ROOTFS="$2"; shift 2;;
262 --mapped-uid) LXC_MAPPED_UID="$2"; shift 2;;
263 --mapped-gid) LXC_MAPPED_GID="$2"; shift 2;;
264 *) break;;
265 esac
71d3a659
SG
266done
267
268# Check for required binaries
269for bin in tar xz wget; do
832cb182
CB
270 if ! command -V "${bin}" >/dev/null 2>&1; then
271 echo "ERROR: Missing required tool: ${bin}" 1>&2
272 exit 1
273 fi
71d3a659
SG
274done
275
276# Check for GPG
3f7be9d0 277if [ "${DOWNLOAD_VALIDATE}" = "true" ]; then
832cb182
CB
278 if ! command -V gpg >/dev/null 2>&1; then
279 echo "ERROR: Missing recommended tool: gpg" 1>&2
280 echo "You can workaround this by using --no-validate" 1>&2
281 exit 1
282 fi
71d3a659
SG
283fi
284
285# Check that we have all variables we need
3f7be9d0 286if [ -z "${LXC_NAME}" ] || [ -z "${LXC_PATH}" ] || [ -z "${LXC_ROOTFS}" ]; then
832cb182
CB
287 if [ "${DOWNLOAD_LIST_IMAGES}" != "true" ]; then
288 echo "ERROR: Please pass the name, path, and rootfs for the container" 1>&2
289 exit 1
290 fi
71d3a659
SG
291fi
292
3f7be9d0 293USERNS="$(in_userns)"
f74e080c 294
3f7be9d0 295if [ "${USERNS}" != "no" ]; then
832cb182
CB
296 if [ "${USERNS}" = "yes" ]; then
297 if [ -z "${LXC_MAPPED_UID}" ] || [ "${LXC_MAPPED_UID}" = "-1" ]; then
298 echo "ERROR: In a user namespace without a map" 1>&2
299 exit 1
71d3a659 300 fi
832cb182
CB
301 DOWNLOAD_MODE="user"
302 DOWNLOAD_TARGET="user"
303 else
304 DOWNLOAD_MODE="user"
305 DOWNLOAD_TARGET="system"
306 fi
71d3a659
SG
307fi
308
832cb182
CB
309if [ -z "${DOWNLOAD_DIST}" ] || [ -z "${DOWNLOAD_RELEASE}" ] || [ -z "${DOWNLOAD_ARCH}" ]; then
310 DOWNLOAD_INTERACTIVE="true"
71d3a659
SG
311fi
312
313# Trap all exit signals
314trap cleanup EXIT HUP INT TERM
843a5874 315
edb5452c
SC
316# /tmp may be mounted in tmpfs or noexec
317if mountpoint -q /tmp; then
832cb182 318 DOWNLOAD_TEMP="${LXC_PATH}"
edb5452c
SC
319fi
320
3f7be9d0 321if ! command -V mktemp >/dev/null 2>&1; then
832cb182 322 DOWNLOAD_TEMP="${DOWNLOAD_TEMP}/tmp/lxc-download.$$"
30c8676e
CB
323elif [ -n "${DOWNLOAD_TEMP}" ]; then
324 mkdir -p "${DOWNLOAD_TEMP}"
6e62213e 325 DOWNLOAD_TEMP="$(mktemp -p ${DOWNLOAD_TEMP} -d)"
30c8676e
CB
326else
327 DOWNLOAD_TEMP="${DOWNLOAD_TEMP}$(mktemp -d)"
843a5874 328fi
71d3a659 329
10a5fab6 330# Simply list images
832cb182
CB
331if [ "${DOWNLOAD_LIST_IMAGES}" = "true" ] || [ "${DOWNLOAD_INTERACTIVE}" = "true" ]; then
332 # Initialize GPG
333 gpg_setup
334
335 # Grab the index
336 DOWNLOAD_INDEX_PATH="/meta/1.0/index-${DOWNLOAD_MODE}"
337
338 echo "Downloading the image index"
339 if ! download_file "${DOWNLOAD_INDEX_PATH}.${DOWNLOAD_COMPAT_LEVEL}" "${DOWNLOAD_TEMP}/index" noexit ||
340 ! download_sig "${DOWNLOAD_INDEX_PATH}.${DOWNLOAD_COMPAT_LEVEL}.asc" "${DOWNLOAD_TEMP}/index.asc" noexit; then
341 download_file "${DOWNLOAD_INDEX_PATH}" "${DOWNLOAD_TEMP}/index" normal
342 download_sig "${DOWNLOAD_INDEX_PATH}.asc" "${DOWNLOAD_TEMP}/index.asc" normal
343 fi
344
345 gpg_validate "${DOWNLOAD_TEMP}/index.asc"
346
347 # Parse it
348 echo ""
349 echo "---"
350 printf "DIST\tRELEASE\tARCH\tVARIANT\tBUILD\n"
351 echo "---"
352 while IFS=';' read -r f1 f2 f3 f4 f5 f6; do
353 [ -n "${DOWNLOAD_DIST}" ] && [ "$f1" != "${DOWNLOAD_DIST}" ] && continue
354 [ -n "${DOWNLOAD_RELEASE}" ] && [ "$f2" != "${DOWNLOAD_RELEASE}" ] && continue
355 [ -n "${DOWNLOAD_ARCH}" ] && [ "$f3" != "${DOWNLOAD_ARCH}" ] && continue
356 [ -n "${DOWNLOAD_VARIANT}" ] && [ "$f4" != "${DOWNLOAD_VARIANT}" ] && continue
357 [ -z "${f5}" ] || [ -z "${f6}" ] && continue
358
359 printf "%s\t%s\t%s\t%s\t%s\n" "${f1}" "${f2}" "${f3}" "${f4}" "${f5}"
360 unset f1 f2 f3 f4 f5 f6
361 done < "${DOWNLOAD_TEMP}/index"
362 echo "---"
363
364 if [ "${DOWNLOAD_LIST_IMAGES}" = "true" ]; then
365 exit 1
366 fi
b0f0932a 367
832cb182
CB
368 # Interactive mode
369 echo ""
b0f0932a 370
832cb182
CB
371 if [ -z "${DOWNLOAD_DIST}" ]; then
372 echo "Distribution: "
373 read -r DOWNLOAD_DIST
374 fi
b0f0932a 375
832cb182
CB
376 if [ -z "${DOWNLOAD_RELEASE}" ]; then
377 echo "Release: "
378 read -r DOWNLOAD_RELEASE
379 fi
b0f0932a 380
832cb182
CB
381 if [ -z "${DOWNLOAD_ARCH}" ]; then
382 echo "Architecture: "
383 read -r DOWNLOAD_ARCH
384 fi
b0f0932a 385
832cb182 386 echo ""
10a5fab6
SG
387fi
388
71d3a659 389# Setup the cache
3f7be9d0 390if [ "${DOWNLOAD_TARGET}" = "system" ]; then
832cb182 391 LXC_CACHE_BASE="${LOCALSTATEDIR}/cache/lxc/"
71d3a659 392else
832cb182 393 LXC_CACHE_BASE="${HOME}/.cache/lxc/"
71d3a659
SG
394fi
395
6dc6f80b 396# Allow the setting of the LXC_CACHE_PATH with the usage of environment variables.
3f7be9d0
WG
397LXC_CACHE_PATH="${LXC_CACHE_PATH:-"${LXC_CACHE_BASE}"}"
398LXC_CACHE_PATH="${LXC_CACHE_PATH}/download/${DOWNLOAD_DIST}"
399LXC_CACHE_PATH="${LXC_CACHE_PATH}/${DOWNLOAD_RELEASE}/${DOWNLOAD_ARCH}/"
400LXC_CACHE_PATH="${LXC_CACHE_PATH}/${DOWNLOAD_VARIANT}"
b56661fe 401
3f7be9d0 402if [ -d "${LXC_CACHE_PATH}" ]; then
832cb182
CB
403 if [ "${DOWNLOAD_FLUSH_CACHE}" = "true" ]; then
404 echo "Flushing the cache..."
405 rm -Rf "${LXC_CACHE_PATH}"
406 elif [ "${DOWNLOAD_FORCE_CACHE}" = "true" ]; then
407 DOWNLOAD_USE_CACHE="true"
408 else
409 DOWNLOAD_USE_CACHE="true"
410 if [ -e "$(relevant_file expiry)" ]; then
411 if [ "$(cat "$(relevant_file expiry)")" -lt "$(date +%s)" ]; then
412 echo "The cached copy has expired, re-downloading..."
413 DOWNLOAD_USE_CACHE="false"
414 fi
71d3a659 415 fi
832cb182 416 fi
71d3a659
SG
417fi
418
419# Download what's needed
3f7be9d0 420if [ "${DOWNLOAD_USE_CACHE}" = "false" ]; then
832cb182
CB
421 # Initialize GPG
422 gpg_setup
423
424 # Grab the index
425 DOWNLOAD_INDEX_PATH="/meta/1.0/index-${DOWNLOAD_MODE}"
426
427 echo "Downloading the image index"
428 if ! download_file "${DOWNLOAD_INDEX_PATH}.${DOWNLOAD_COMPAT_LEVEL}" "${DOWNLOAD_TEMP}/index" noexit ||
429 ! download_sig "${DOWNLOAD_INDEX_PATH}.${DOWNLOAD_COMPAT_LEVEL}.asc" "${DOWNLOAD_TEMP}/index.asc" noexit; then
430 download_file "${DOWNLOAD_INDEX_PATH}" "${DOWNLOAD_TEMP}/index" normal
431 download_sig "${DOWNLOAD_INDEX_PATH}.asc" "${DOWNLOAD_TEMP}/index.asc" normal
432 fi
433
434 gpg_validate "${DOWNLOAD_TEMP}/index.asc"
435
436 # Parse it
437 while IFS=';' read -r f1 f2 f3 f4 f5 f6; do
438 if [ "${f1}" != "${DOWNLOAD_DIST}" ] || \
439 [ "${f2}" != "${DOWNLOAD_RELEASE}" ] || \
440 [ "${f3}" != "${DOWNLOAD_ARCH}" ] || \
441 [ "${f4}" != "${DOWNLOAD_VARIANT}" ] || \
442 [ -z "${f6}" ]; then
443 continue
71d3a659
SG
444 fi
445
832cb182
CB
446 DOWNLOAD_BUILD="${f5}"
447 DOWNLOAD_URL="${f6}"
71d3a659 448
832cb182
CB
449 unset f1 f2 f3 f4 f5 f6
450 break
451 done < "${DOWNLOAD_TEMP}/index"
3f7be9d0 452
832cb182
CB
453 if [ -z "${DOWNLOAD_URL}" ]; then
454 echo "ERROR: Couldn't find a matching image" 1>&1
455 exit 1
456 fi
71d3a659 457
832cb182
CB
458 if [ -d "${LXC_CACHE_PATH}" ] && [ -f "${LXC_CACHE_PATH}/build_id" ] && \
459 [ "$(cat "${LXC_CACHE_PATH}/build_id")" = "${DOWNLOAD_BUILD}" ]; then
460 echo "The cache is already up to date"
461 echo "Using image from local cache"
462 else
463 # Download the actual files
464 echo "Downloading the rootfs"
465 download_file "${DOWNLOAD_URL}/rootfs.tar.xz" "${DOWNLOAD_TEMP}/rootfs.tar.xz" normal
466 download_sig "${DOWNLOAD_URL}/rootfs.tar.xz.asc" "${DOWNLOAD_TEMP}/rootfs.tar.xz.asc" normal
467 gpg_validate "${DOWNLOAD_TEMP}/rootfs.tar.xz.asc"
468
469 echo "Downloading the metadata"
470 download_file "${DOWNLOAD_URL}/meta.tar.xz" "${DOWNLOAD_TEMP}/meta.tar.xz" normal
471 download_sig "$DOWNLOAD_URL/meta.tar.xz.asc" "${DOWNLOAD_TEMP}/meta.tar.xz.asc" normal
472 gpg_validate "${DOWNLOAD_TEMP}/meta.tar.xz.asc"
473
474 if [ -d "${LXC_CACHE_PATH}" ]; then
475 rm -Rf "${LXC_CACHE_PATH}"
476 fi
477 mkdir -p "${LXC_CACHE_PATH}"
478 mv "${DOWNLOAD_TEMP}/rootfs.tar.xz" "${LXC_CACHE_PATH}"
479 if ! tar Jxf "${DOWNLOAD_TEMP}/meta.tar.xz" -C "${LXC_CACHE_PATH}"; then
480 echo "ERROR: Invalid rootfs tarball." 2>&1
481 exit 1
482 fi
3f7be9d0 483
832cb182 484 echo "${DOWNLOAD_BUILD}" > "${LXC_CACHE_PATH}/build_id"
71d3a659 485
832cb182
CB
486 if [ -n "${LXC_MAPPED_UID}" ] && [ "${LXC_MAPPED_UID}" != "-1" ]; then
487 # As the script is run in strict mode (set -eu), all commands
488 # exiting with non 0 would make the script stop.
489 # || true or || : (more portable) prevents that.
490 chown -R "${LXC_MAPPED_UID}" "${LXC_CACHE_BASE}" >/dev/null 2>&1 || :
71d3a659 491 fi
832cb182
CB
492 if [ -n "${LXC_MAPPED_GID}" ] && [ "${LXC_MAPPED_GID}" != "-1" ]; then
493 chgrp -R "${LXC_MAPPED_GID}" "${LXC_CACHE_BASE}" >/dev/null 2>&1 || :
71d3a659 494 fi
832cb182
CB
495 echo "The image cache is now ready"
496 fi
71d3a659 497else
832cb182 498 echo "Using image from local cache"
71d3a659
SG
499fi
500
501# Unpack the rootfs
502echo "Unpacking the rootfs"
fecf101c
SG
503
504EXCLUDES=""
505excludelist=$(relevant_file excludes)
506if [ -f "${excludelist}" ]; then
832cb182
CB
507 while read -r line; do
508 EXCLUDES="${EXCLUDES} --exclude=${line}"
509 done < "${excludelist}"
71d3a659
SG
510fi
511
3f7be9d0
WG
512# Do not surround ${EXCLUDES} by quotes. This does not work. The solution could
513# use array but this is not POSIX compliant. The only POSIX compliant solution
514# is to use a function wrapper, but the latter can't be used here as the args
515# are dynamic. We thus need to ignore the warning brought by shellcheck.
516# shellcheck disable=SC2086
832cb182 517tar --anchored ${EXCLUDES} --numeric-owner -xpJf "${LXC_CACHE_PATH}/rootfs.tar.xz" -C "${LXC_ROOTFS}"
fecf101c 518
3f7be9d0 519mkdir -p "${LXC_ROOTFS}/dev/pts/"
fecf101c 520
71d3a659 521# Setup the configuration
3f7be9d0
WG
522configfile="$(relevant_file config)"
523fstab="$(relevant_file fstab)"
524if [ ! -e "${configfile}" ]; then
832cb182
CB
525 echo "ERROR: meta tarball is missing the configuration file" 1>&2
526 exit 1
71d3a659
SG
527fi
528
529## Extract all the network config entries
832cb182 530sed -i -e "/lxc.net.0/{w ${LXC_PATH}/config-network" -e "d}" "${LXC_PATH}/config"
71d3a659
SG
531
532## Extract any other config entry
3f7be9d0 533sed -i -e "/lxc./{w ${LXC_PATH}/config-auto" -e "d}" "${LXC_PATH}/config"
71d3a659
SG
534
535## Append the defaults
832cb182
CB
536{
537 echo ""
538 echo "# Distribution configuration"
539 cat "$configfile"
540} >> "${LXC_PATH}/config"
71d3a659
SG
541
542## Add the container-specific config
832cb182
CB
543{
544 echo ""
545 echo "# Container specific configuration"
546 if [ -e "${LXC_PATH}/config-auto" ]; then
547 cat "${LXC_PATH}/config-auto"
3f7be9d0 548 rm "${LXC_PATH}/config-auto"
832cb182
CB
549 fi
550 if [ -e "${fstab}" ]; then
551 echo "lxc.mount.fstab = ${LXC_PATH}/fstab"
552 fi
553 echo "lxc.uts.name = ${LXC_NAME}"
554} >> "${LXC_PATH}/config"
71d3a659
SG
555
556## Re-add the previously removed network config
557if [ -e "${LXC_PATH}/config-network" ]; then
832cb182
CB
558 {
559 echo ""
560 echo "# Network configuration"
561 cat "${LXC_PATH}/config-network"
3f7be9d0 562 rm "${LXC_PATH}/config-network"
832cb182 563 } >> "${LXC_PATH}/config"
71d3a659
SG
564fi
565
566TEMPLATE_FILES="${LXC_PATH}/config"
567
568# Setup the fstab
3f7be9d0 569if [ -e "${fstab}" ]; then
832cb182
CB
570 cp "${fstab}" "${LXC_PATH}/fstab"
571 TEMPLATE_FILES="${TEMPLATE_FILES};${LXC_PATH}/fstab"
71d3a659
SG
572fi
573
574# Look for extra templates
575if [ -e "$(relevant_file templates)" ]; then
832cb182
CB
576 while read -r line; do
577 fullpath="${LXC_ROOTFS}/${line}"
578 [ ! -e "${fullpath}" ] && continue
579 TEMPLATE_FILES="${TEMPLATE_FILES};${fullpath}"
580 done < "$(relevant_file templates)"
71d3a659
SG
581fi
582
583# Replace variables in all templates
3f7be9d0
WG
584OLD_IFS=${IFS}
585IFS=";"
586for file in ${TEMPLATE_FILES}; do
587 [ ! -f "${file}" ] && continue
832cb182
CB
588 sed -i "s#LXC_NAME#${LXC_NAME}#g" "${file}"
589 sed -i "s#LXC_PATH#${LXC_PATH}#g" "${file}"
590 sed -i "s#LXC_ROOTFS#${LXC_ROOTFS}#g" "${file}"
591 sed -i "s#LXC_TEMPLATE_CONFIG#${LXC_TEMPLATE_CONFIG}#g" "${file}"
592 sed -i "s#LXC_HOOK_DIR#${LXC_HOOK_DIR}#g" "${file}"
71d3a659 593done
3f7be9d0 594IFS=${OLD_IFS}
71d3a659 595
491a01cf 596# prevent mingetty from calling vhangup(2) since it fails with userns on CentOS / Oracle
3f7be9d0 597if [ -f "${LXC_ROOTFS}/etc/init/tty.conf" ]; then
832cb182 598 sed -i 's|mingetty|mingetty --nohangup|' "${LXC_ROOTFS}/etc/init/tty.conf"
6e53ca56
SC
599fi
600
3f7be9d0 601if [ -n "${LXC_MAPPED_UID}" ] && [ "${LXC_MAPPED_UID}" != "-1" ]; then
832cb182 602 chown "${LXC_MAPPED_UID}" "${LXC_PATH}/config" "${LXC_PATH}/fstab" >/dev/null 2>&1 || :
71d3a659 603fi
832cb182 604
3f7be9d0 605if [ -n "${LXC_MAPPED_GID}" ] && [ "${LXC_MAPPED_GID}" != "-1" ]; then
832cb182 606 chgrp "${LXC_MAPPED_GID}" "${LXC_PATH}/config" "${LXC_PATH}/fstab" >/dev/null 2>&1 || :
2133f58c 607fi
71d3a659
SG
608
609if [ -e "$(relevant_file create-message)" ]; then
832cb182
CB
610 echo ""
611 echo "---"
612 cat "$(relevant_file create-message)"
71d3a659
SG
613fi
614
615exit 0